org.apache.commons.math3.stat.descriptive.summary

## Class SumOfLogs

- java.lang.Object
- - org.apache.commons.math3.stat.descriptive.AbstractUnivariateStatistic
  - - org.apache.commons.math3.stat.descriptive.AbstractStorelessUnivariateStatistic
    - - org.apache.commons.math3.stat.descriptive.summary.SumOfLogs

All Implemented Interfaces:
  Serializable, StorelessUnivariateStatistic, UnivariateStatistic, MathArrays.Function

    public class SumOfLogs
    extends AbstractStorelessUnivariateStatistic
    implements Serializable

Returns the sum of the natural logs for this collection of values.

Uses `FastMath.log(double)` to compute the logs. Therefore,

- If any of values are < 0, the result is `NaN.`
- If all values are non-negative and less than `Double.POSITIVE_INFINITY`, but at least one value is 0, the result is `Double.NEGATIVE_INFINITY.`
- If both `Double.POSITIVE_INFINITY` and `Double.NEGATIVE_INFINITY` are among the values, the result is `NaN.`

Note that this implementation is not synchronized. If multiple threads access an instance of this class concurrently, and at least one of the threads invokes the `increment()` or `clear()` method, it must be synchronized externally.

Version:
  $Id: SumOfLogs.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  Serialized Form

### Field Summary

Fields
`private int` `n` Number of values that have been added
`private static long` `serialVersionUID` Serializable version identifier
`private double` `value` The currently running value

### Constructor Summary

Constructors
Constructor and Description
`SumOfLogs()` Create a SumOfLogs instance
`SumOfLogs(SumOfLogs original)` Copy constructor, creates a new `SumOfLogs` identical to the `original`

### Method Summary

Methods
`void` `clear()` Clears the internal state of the Statistic
`SumOfLogs` `copy()` Returns a copy of the statistic with the same internal state.
`static void` `copy(SumOfLogs source, SumOfLogs dest)` Copies source to dest.
`double` `evaluate(double[] values, int begin, int length)` Returns the sum of the natural logs of the entries in the specified portion of the input array, or `Double.NaN` if the designated subarray is empty.
`long` `getN()` Returns the number of values that have been added.
`double` `getResult()` Returns the current value of the Statistic.
`void` `increment(double d)` Updates the internal state of the statistic to reflect the addition of the new value.

### Methods inherited from class org.apache.commons.math3.stat.descriptive.AbstractStorelessUnivariateStatistic

`equals, evaluate, hashCode, incrementAll, incrementAll`

### Methods inherited from class org.apache.commons.math3.stat.descriptive.AbstractUnivariateStatistic

`evaluate, getData, getDataRef, setData, setData, test, test, test, test`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### serialVersionUID

    private static final long serialVersionUID

Serializable version identifier

See Also:
  Constant Field Values

#### n

    private int n

Number of values that have been added

#### value

    private double value

The currently running value

### Constructor Detail

#### SumOfLogs

    public SumOfLogs()

Create a SumOfLogs instance

#### SumOfLogs

    public SumOfLogs(SumOfLogs original)
              throws NullArgumentException

Copy constructor, creates a new `SumOfLogs` identical to the `original`

Parameters:
  `original` - the `SumOfLogs` instance to copy
Throws:
  `NullArgumentException` - if original is null

### Method Detail

#### increment

    public void increment(double d)

Updates the internal state of the statistic to reflect the addition of the new value.

Specified by:
  `increment` in interface `StorelessUnivariateStatistic`
Specified by:
  `increment` in class `AbstractStorelessUnivariateStatistic`
Parameters:
  `d` - the new value.

#### getResult

    public double getResult()

Returns the current value of the Statistic.

Specified by:
  `getResult` in interface `StorelessUnivariateStatistic`
Specified by:
  `getResult` in class `AbstractStorelessUnivariateStatistic`
Returns:
  value of the statistic, `Double.NaN` if it has been cleared or just instantiated.

#### getN

    public long getN()

Returns the number of values that have been added.

Specified by:
  `getN` in interface `StorelessUnivariateStatistic`
Returns:
  the number of values.

#### clear

    public void clear()

Clears the internal state of the Statistic

Specified by:
  `clear` in interface `StorelessUnivariateStatistic`
Specified by:
  `clear` in class `AbstractStorelessUnivariateStatistic`

#### evaluate

    public double evaluate(double[] values,
                  int begin,
                  int length)
                    throws MathIllegalArgumentException

Returns the sum of the natural logs of the entries in the specified portion of the input array, or `Double.NaN` if the designated subarray is empty.

Throws `MathIllegalArgumentException` if the array is null.

See `SumOfLogs`.

Specified by:
  `evaluate` in interface `UnivariateStatistic`
Specified by:
  `evaluate` in interface `MathArrays.Function`
Overrides:
  `evaluate` in class `AbstractStorelessUnivariateStatistic`
Parameters:
  `values` - the input array
  `begin` - index of the first array element to include
  `length` - the number of elements to include
Returns:
  the sum of the natural logs of the values or 0 if length = 0
Throws:
  `MathIllegalArgumentException` - if the array is null or the array index parameters are not valid
See Also:
  `UnivariateStatistic.evaluate(double[], int, int)`

#### copy

    public SumOfLogs copy()

Returns a copy of the statistic with the same internal state.

Specified by:
  `copy` in interface `StorelessUnivariateStatistic`
Specified by:
  `copy` in interface `UnivariateStatistic`
Specified by:
  `copy` in class `AbstractStorelessUnivariateStatistic`
Returns:
  a copy of the statistic

#### copy

    public static void copy(SumOfLogs source,
            SumOfLogs dest)
                     throws NullArgumentException

Copies source to dest.

Neither source nor dest can be null.

Parameters:
  `source` - SumOfLogs to copy
  `dest` - SumOfLogs to copy to
Throws:
  `NullArgumentException` - if either source or dest is null